<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
    <!-- Generated by javadoc -->
    <title>CryptoFunctions (POI API Documentation)</title>
    <link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
    <script type="text/javascript" src="../../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="CryptoFunctions (POI API Documentation)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":9,"i1":9,"i2":9,"i3":9,"i4":9,"i5":9,"i6":9,"i7":9,"i8":9,"i9":9,"i10":9,"i11":9,"i12":9,"i13":9,"i14":9,"i15":9};
var tabs = {65535:["t0","All Methods"],1:["t1","Static Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";

</script>
<noscript>
    <div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
    <!--   -->
</a>
    <div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
    <a name="navbar.top.firstrow">
        <!--   -->
    </a>
    <ul class="navList" title="Navigation">
        <li><a href="../../../../../overview-summary.html">Overview</a></li>
        <li><a href="package-summary.html">Package</a></li>
        <li class="navBarCell1Rev">Class</li>
        <li><a href="class-use/CryptoFunctions.html">Use</a></li>
        <li><a href="package-tree.html">Tree</a></li>
        <li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
        <li><a href="../../../../../index-all.html">Index</a></li>
        <li><a href="../../../../../help-doc.html">Help</a></li>
    </ul>
</div>
<div class="subNav">
    <ul class="navList">
        <li><a href="../../../../../org/apache/poi/poifs/crypt/CipherProvider.html"
               title="enum in org.apache.poi.poifs.crypt"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
        <li><a href="../../../../../org/apache/poi/poifs/crypt/DataSpaceMapUtils.html"
               title="class in org.apache.poi.poifs.crypt"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
    </ul>
    <ul class="navList">
        <li><a href="../../../../../index.html?org/apache/poi/poifs/crypt/CryptoFunctions.html" target="_top">Frames</a>
        </li>
        <li><a href="CryptoFunctions.html" target="_top">No&nbsp;Frames</a></li>
    </ul>
    <ul class="navList" id="allclasses_navbar_top">
        <li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
    </ul>
    <div>
        <script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->

        </script>
    </div>
    <div>
        <ul class="subNavList">
            <li>Summary:&nbsp;</li>
            <li>Nested&nbsp;|&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.summary">Method</a></li>
        </ul>
        <ul class="subNavList">
            <li>Detail:&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.detail">Method</a></li>
        </ul>
    </div>
    <a name="skip.navbar.top">
        <!--   -->
    </a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
    <div class="subTitle">org.apache.poi.poifs.crypt</div>
    <h2 title="Class CryptoFunctions" class="title">Class CryptoFunctions</h2>
</div>
<div class="contentContainer">
    <ul class="inheritance">
        <li>java.lang.Object</li>
        <li>
            <ul class="inheritance">
                <li>org.apache.poi.poifs.crypt.CryptoFunctions</li>
            </ul>
        </li>
    </ul>
    <div class="description">
        <ul class="blockList">
            <li class="blockList">
                <hr>
                <br>
                <pre><a href="../../../../../org/apache/poi/util/Internal.html"
                        title="annotation in org.apache.poi.util">@Internal</a>
public class <span class="typeNameLabel">CryptoFunctions</span>
extends java.lang.Object</pre>
                <div class="block">Helper functions used for standard and agile encryption</div>
            </li>
        </ul>
    </div>
    <div class="summary">
        <ul class="blockList">
            <li class="blockList">
                <!-- ======== CONSTRUCTOR SUMMARY ======== -->
                <ul class="blockList">
                    <li class="blockList"><a name="constructor.summary">
                        <!--   -->
                    </a>
                        <h3>Constructor Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Constructor Summary table, listing constructors, and an explanation">
                            <caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
                            <tr>
                                <th class="colOne" scope="col">Constructor and Description</th>
                            </tr>
                            <tr class="altColor">
                                <td class="colOne"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/crypt/CryptoFunctions.html#CryptoFunctions--">CryptoFunctions</a></span>()</code>&nbsp;
                                </td>
                            </tr>
                        </table>
                    </li>
                </ul>
                <!-- ========== METHOD SUMMARY =========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="method.summary">
                        <!--   -->
                    </a>
                        <h3>Method Summary</h3>
                        <table class="memberSummary" border="0" cellpadding="3" cellspacing="0"
                               summary="Method Summary table, listing methods, and an explanation">
                            <caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span
                                    id="t1" class="tableTab"><span><a
                                    href="javascript:show(1);">Static Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a
                                    href="javascript:show(8);">Concrete Methods</a></span><span
                                    class="tabEnd">&nbsp;</span></span></caption>
                            <tr>
                                <th class="colFirst" scope="col">Modifier and Type</th>
                                <th class="colLast" scope="col">Method and Description</th>
                            </tr>
                            <tr id="i0" class="altColor">
                                <td class="colFirst"><code>static byte[]</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/crypt/CryptoFunctions.html#createXorArray1-java.lang.String-">createXorArray1</a></span>(java.lang.String&nbsp;password)</code>
                                    <div class="block">Creates an byte array for xor obfuscation (method 1)</div>
                                </td>
                            </tr>
                            <tr id="i1" class="rowColor">
                                <td class="colFirst"><code>static int</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/crypt/CryptoFunctions.html#createXorKey1-java.lang.String-">createXorKey1</a></span>(java.lang.String&nbsp;password)</code>
                                    <div class="block">Create the xor key for xor obfuscation, which is used to create
                                        the xor array (method 1)
                                    </div>
                                </td>
                            </tr>
                            <tr id="i2" class="altColor">
                                <td class="colFirst"><code>static int</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/crypt/CryptoFunctions.html#createXorVerifier1-java.lang.String-">createXorVerifier1</a></span>(java.lang.String&nbsp;password)</code>
                                    <div class="block">Create the verifier for xor obfuscation (method 1)</div>
                                </td>
                            </tr>
                            <tr id="i3" class="rowColor">
                                <td class="colFirst"><code>static int</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/crypt/CryptoFunctions.html#createXorVerifier2-java.lang.String-">createXorVerifier2</a></span>(java.lang.String&nbsp;password)</code>
                                    <div class="block">This method generates the xor verifier for word documents &lt;
                                        2007 (method 2).
                                    </div>
                                </td>
                            </tr>
                            <tr id="i4" class="altColor">
                                <td class="colFirst"><code>static byte[]</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/crypt/CryptoFunctions.html#generateIv-org.apache.poi.poifs.crypt.HashAlgorithm-byte:A-byte:A-int-">generateIv</a></span>(<a
                                        href="../../../../../org/apache/poi/poifs/crypt/HashAlgorithm.html"
                                        title="enum in org.apache.poi.poifs.crypt">HashAlgorithm</a>&nbsp;hashAlgorithm,
                                    byte[]&nbsp;salt,
                                    byte[]&nbsp;blockKey,
                                    int&nbsp;blockSize)</code>
                                    <div class="block"><cite>2.3.4.12 Initialization Vector Generation (Agile
                                        Encryption)</cite></div>
                                </td>
                            </tr>
                            <tr id="i5" class="rowColor">
                                <td class="colFirst"><code>static byte[]</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/crypt/CryptoFunctions.html#generateKey-byte:A-org.apache.poi.poifs.crypt.HashAlgorithm-byte:A-int-">generateKey</a></span>(byte[]&nbsp;passwordHash,
                                    <a href="../../../../../org/apache/poi/poifs/crypt/HashAlgorithm.html"
                                       title="enum in org.apache.poi.poifs.crypt">HashAlgorithm</a>&nbsp;hashAlgorithm,
                                    byte[]&nbsp;blockKey,
                                    int&nbsp;keySize)</code>
                                    <div class="block"><cite>2.3.4.11 Encryption Key Generation (Agile
                                        Encryption)</cite></div>
                                </td>
                            </tr>
                            <tr id="i6" class="altColor">
                                <td class="colFirst"><code>static byte[]</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/crypt/CryptoFunctions.html#getBlock0-byte:A-int-">getBlock0</a></span>(byte[]&nbsp;hash,
                                    int&nbsp;size)</code>
                                    <div class="block">Returns a new byte array with a truncated to the given size.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i7" class="rowColor">
                                <td class="colFirst"><code>static javax.crypto.Cipher</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/crypt/CryptoFunctions.html#getCipher-java.security.Key-org.apache.poi.poifs.crypt.CipherAlgorithm-org.apache.poi.poifs.crypt.ChainingMode-byte:A-int-java.lang.String-">getCipher</a></span>(java.security.Key&nbsp;key,
                                    <a href="../../../../../org/apache/poi/poifs/crypt/CipherAlgorithm.html"
                                       title="enum in org.apache.poi.poifs.crypt">CipherAlgorithm</a>&nbsp;cipherAlgorithm,
                                    <a href="../../../../../org/apache/poi/poifs/crypt/ChainingMode.html"
                                       title="enum in org.apache.poi.poifs.crypt">ChainingMode</a>&nbsp;chain,
                                    byte[]&nbsp;vec,
                                    int&nbsp;cipherMode,
                                    java.lang.String&nbsp;padding)</code>
                                    <div class="block">Initialize a new cipher object with the given cipher properties
                                        If the given algorithm is not implemented in the JCE, it will try to load it
                                        from the bouncy castle
                                        provider.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i8" class="altColor">
                                <td class="colFirst"><code>static javax.crypto.Cipher</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/crypt/CryptoFunctions.html#getCipher-javax.crypto.SecretKey-org.apache.poi.poifs.crypt.CipherAlgorithm-org.apache.poi.poifs.crypt.ChainingMode-byte:A-int-">getCipher</a></span>(javax.crypto.SecretKey&nbsp;key,
                                    <a href="../../../../../org/apache/poi/poifs/crypt/CipherAlgorithm.html"
                                       title="enum in org.apache.poi.poifs.crypt">CipherAlgorithm</a>&nbsp;cipherAlgorithm,
                                    <a href="../../../../../org/apache/poi/poifs/crypt/ChainingMode.html"
                                       title="enum in org.apache.poi.poifs.crypt">ChainingMode</a>&nbsp;chain,
                                    byte[]&nbsp;vec,
                                    int&nbsp;cipherMode)</code>
                                    <div class="block">Initialize a new cipher object with the given cipher properties
                                        and no padding
                                        If the given algorithm is not implemented in the JCE, it will try to load it
                                        from the bouncy castle
                                        provider.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i9" class="rowColor">
                                <td class="colFirst"><code>static javax.crypto.Mac</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/crypt/CryptoFunctions.html#getMac-org.apache.poi.poifs.crypt.HashAlgorithm-">getMac</a></span>(<a
                                        href="../../../../../org/apache/poi/poifs/crypt/HashAlgorithm.html"
                                        title="enum in org.apache.poi.poifs.crypt">HashAlgorithm</a>&nbsp;hashAlgorithm)</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i10" class="altColor">
                                <td class="colFirst"><code>static java.security.MessageDigest</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/crypt/CryptoFunctions.html#getMessageDigest-org.apache.poi.poifs.crypt.HashAlgorithm-">getMessageDigest</a></span>(<a
                                        href="../../../../../org/apache/poi/poifs/crypt/HashAlgorithm.html"
                                        title="enum in org.apache.poi.poifs.crypt">HashAlgorithm</a>&nbsp;hashAlgorithm)</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i11" class="rowColor">
                                <td class="colFirst"><code>static byte[]</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/crypt/CryptoFunctions.html#hashPassword-java.lang.String-org.apache.poi.poifs.crypt.HashAlgorithm-byte:A-int-">hashPassword</a></span>(java.lang.String&nbsp;password,
                                    <a href="../../../../../org/apache/poi/poifs/crypt/HashAlgorithm.html"
                                       title="enum in org.apache.poi.poifs.crypt">HashAlgorithm</a>&nbsp;hashAlgorithm,
                                    byte[]&nbsp;salt,
                                    int&nbsp;spinCount)</code>
                                    <div class="block"><cite>2.3.4.7 ECMA-376 Document Encryption Key Generation
                                        (Standard Encryption)<br>
                                        2.3.4.11 Encryption Key Generation (Agile Encryption)</cite></div>
                                </td>
                            </tr>
                            <tr id="i12" class="altColor">
                                <td class="colFirst"><code>static byte[]</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/crypt/CryptoFunctions.html#hashPassword-java.lang.String-org.apache.poi.poifs.crypt.HashAlgorithm-byte:A-int-boolean-">hashPassword</a></span>(java.lang.String&nbsp;password,
                                    <a href="../../../../../org/apache/poi/poifs/crypt/HashAlgorithm.html"
                                       title="enum in org.apache.poi.poifs.crypt">HashAlgorithm</a>&nbsp;hashAlgorithm,
                                    byte[]&nbsp;salt,
                                    int&nbsp;spinCount,
                                    boolean&nbsp;iteratorFirst)</code>
                                    <div class="block">Generalized method for read and write protection hash
                                        generation.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i13" class="rowColor">
                                <td class="colFirst"><code>static void</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/crypt/CryptoFunctions.html#registerBouncyCastle--">registerBouncyCastle</a></span>()</code>&nbsp;
                                </td>
                            </tr>
                            <tr id="i14" class="altColor">
                                <td class="colFirst"><code>static java.lang.String</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/crypt/CryptoFunctions.html#xorHashPassword-java.lang.String-">xorHashPassword</a></span>(java.lang.String&nbsp;password)</code>
                                    <div class="block">This method generates the xored-hashed password for word
                                        documents &lt; 2007.
                                    </div>
                                </td>
                            </tr>
                            <tr id="i15" class="rowColor">
                                <td class="colFirst"><code>static java.lang.String</code></td>
                                <td class="colLast"><code><span class="memberNameLink"><a
                                        href="../../../../../org/apache/poi/poifs/crypt/CryptoFunctions.html#xorHashPasswordReversed-java.lang.String-">xorHashPasswordReversed</a></span>(java.lang.String&nbsp;password)</code>
                                    <div class="block">Convenience function which returns the reversed xored-hashed
                                        password for further
                                        processing in word documents 2007 and newer, which utilize a real hashing
                                        algorithm like sha1.
                                    </div>
                                </td>
                            </tr>
                        </table>
                        <ul class="blockList">
                            <li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
                                <!--   -->
                            </a>
                                <h3>Methods inherited from class&nbsp;java.lang.Object</h3>
                                <code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait,
                                    wait, wait</code></li>
                        </ul>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
    <div class="details">
        <ul class="blockList">
            <li class="blockList">
                <!-- ========= CONSTRUCTOR DETAIL ======== -->
                <ul class="blockList">
                    <li class="blockList"><a name="constructor.detail">
                        <!--   -->
                    </a>
                        <h3>Constructor Detail</h3>
                        <a name="CryptoFunctions--">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>CryptoFunctions</h4>
                                <pre>public&nbsp;CryptoFunctions()</pre>
                            </li>
                        </ul>
                    </li>
                </ul>
                <!-- ============ METHOD DETAIL ========== -->
                <ul class="blockList">
                    <li class="blockList"><a name="method.detail">
                        <!--   -->
                    </a>
                        <h3>Method Detail</h3>
                        <a name="hashPassword-java.lang.String-org.apache.poi.poifs.crypt.HashAlgorithm-byte:A-int-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>hashPassword</h4>
                                <pre>public static&nbsp;byte[]&nbsp;hashPassword(java.lang.String&nbsp;password,
                                  <a href="../../../../../org/apache/poi/poifs/crypt/HashAlgorithm.html"
                                     title="enum in org.apache.poi.poifs.crypt">HashAlgorithm</a>&nbsp;hashAlgorithm,
                                  byte[]&nbsp;salt,
                                  int&nbsp;spinCount)</pre>
                                <div class="block"><p><cite>2.3.4.7 ECMA-376 Document Encryption Key Generation
                                    (Standard Encryption)<br>
                                    2.3.4.11 Encryption Key Generation (Agile Encryption)</cite></p>

                                    <p>The encryption key for ECMA-376 document encryption [ECMA-376] using agile
                                        encryption MUST be generated by using the following method, which is derived
                                        from PKCS #5:
                                        <a href="https://www.ietf.org/rfc/rfc2898.txt">Password-Based Cryptography
                                            Version 2.0 [RFC2898]</a>.</p>

                                    <p>Let H() be a hashing algorithm as determined by the
                                        PasswordKeyEncryptor.hashAlgorithm
                                        element, H_n be the hash data of the n-th iteration, and a plus sign (+)
                                        represent concatenation.
                                        The password MUST be provided as an array of Unicode characters. Limitations on
                                        the length of the
                                        password and the characters used by the password are implementation-dependent.
                                        The initial password hash is generated as follows:</p>


                                    <pre>H_0 = H(salt + password)</pre>

                                    <p>The salt used MUST be generated randomly. The salt MUST be stored in the
                                        PasswordKeyEncryptor.saltValue element contained within the \EncryptionInfo
                                        stream as
                                        specified in section 2.3.4.10. The hash is then iterated by using the following
                                        approach:</p>

                                    <pre>H_n = H(iterator + H_n-1)</pre>

                                    <p>where iterator is an unsigned 32-bit value that is initially set to 0x00000000
                                        and then incremented
                                        monotonically on each iteration until PasswordKey.spinCount iterations have been
                                        performed.
                                        The value of iterator on the last iteration MUST be one less than
                                        PasswordKey.spinCount.</p>

                                    <p>For POI, H_final will be calculated by <a
                                            href="../../../../../org/apache/poi/poifs/crypt/CryptoFunctions.html#generateKey-byte:A-org.apache.poi.poifs.crypt.HashAlgorithm-byte:A-int-"><code>generateKey(byte[],HashAlgorithm,byte[],int)</code></a>
                                    </p></div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>password</code> -</dd>
                                    <dd><code>hashAlgorithm</code> -</dd>
                                    <dd><code>salt</code> -</dd>
                                    <dd><code>spinCount</code> -</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>the hashed password</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="hashPassword-java.lang.String-org.apache.poi.poifs.crypt.HashAlgorithm-byte:A-int-boolean-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>hashPassword</h4>
                                <pre>public static&nbsp;byte[]&nbsp;hashPassword(java.lang.String&nbsp;password,
                                  <a href="../../../../../org/apache/poi/poifs/crypt/HashAlgorithm.html"
                                     title="enum in org.apache.poi.poifs.crypt">HashAlgorithm</a>&nbsp;hashAlgorithm,
                                  byte[]&nbsp;salt,
                                  int&nbsp;spinCount,
                                  boolean&nbsp;iteratorFirst)</pre>
                                <div class="block">Generalized method for read and write protection hash generation.
                                    The difference is, read protection uses the order iterator then hash in the hash
                                    loop, whereas write protection
                                    uses first the last hash value and then the current iterator value
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>password</code> -</dd>
                                    <dd><code>hashAlgorithm</code> -</dd>
                                    <dd><code>salt</code> -</dd>
                                    <dd><code>spinCount</code> -</dd>
                                    <dd><code>iteratorFirst</code> - if true, the iterator is hashed before the n-1 hash
                                        value,
                                        if false the n-1 hash value is applied first
                                    </dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>the hashed password</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="generateIv-org.apache.poi.poifs.crypt.HashAlgorithm-byte:A-byte:A-int-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>generateIv</h4>
                                <pre>public static&nbsp;byte[]&nbsp;generateIv(<a
                                        href="../../../../../org/apache/poi/poifs/crypt/HashAlgorithm.html"
                                        title="enum in org.apache.poi.poifs.crypt">HashAlgorithm</a>&nbsp;hashAlgorithm,
                                byte[]&nbsp;salt,
                                byte[]&nbsp;blockKey,
                                int&nbsp;blockSize)</pre>
                                <div class="block"><p><cite>2.3.4.12 Initialization Vector Generation (Agile
                                    Encryption)</cite></p>

                                    <p>Initialization vectors are used in all cases for agile encryption. An
                                        initialization vector MUST be
                                        generated by using the following method, where H() is a hash function that MUST
                                        be the same as
                                        specified in section 2.3.4.11 and a plus sign (+) represents concatenation:</p>
                                    <ul>
                                        <li>If a blockKey is provided, let IV be a hash of the KeySalt and the following
                                            value:<br>
                                            <code>blockKey: IV = H(KeySalt + blockKey)</code></li>
                                        <li>If a blockKey is not provided, let IV be equal to the following value:<br>
                                            <code>KeySalt:IV = KeySalt</code></li>
                                        <li>If the number of bytes in the value of IV is less than the the value of the
                                            blockSize attribute
                                            corresponding to the cipherAlgorithm attribute, pad the array of bytes by
                                            appending 0x36 until
                                            the array is blockSize bytes. If the array of bytes is larger than blockSize
                                            bytes, truncate the
                                            array to blockSize bytes.
                                        </li>
                                    </ul>
                                </div>
                            </li>
                        </ul>
                        <a name="generateKey-byte:A-org.apache.poi.poifs.crypt.HashAlgorithm-byte:A-int-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>generateKey</h4>
                                <pre>public static&nbsp;byte[]&nbsp;generateKey(byte[]&nbsp;passwordHash,
                                 <a href="../../../../../org/apache/poi/poifs/crypt/HashAlgorithm.html"
                                    title="enum in org.apache.poi.poifs.crypt">HashAlgorithm</a>&nbsp;hashAlgorithm,
                                 byte[]&nbsp;blockKey,
                                 int&nbsp;keySize)</pre>
                                <div class="block"><p><cite>2.3.4.11 Encryption Key Generation (Agile Encryption)</cite>
                                </p>

                                    <p>The final hash data that is used for an encryption key is then generated by using
                                        the following
                                        method:</p>

                                    <pre>H_final = H(H_n + blockKey)</pre>

                                    <p>where blockKey represents an array of bytes used to prevent two different blocks
                                        from encrypting
                                        to the same cipher text.</p>

                                    <p>If the size of the resulting H_final is smaller than that of
                                        PasswordKeyEncryptor.keyBits, the key
                                        MUST be padded by appending bytes with a value of 0x36. If the hash value is
                                        larger in size than
                                        PasswordKeyEncryptor.keyBits, the key is obtained by truncating the hash
                                        value.</p></div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>passwordHash</code> -</dd>
                                    <dd><code>hashAlgorithm</code> -</dd>
                                    <dd><code>blockKey</code> -</dd>
                                    <dd><code>keySize</code> -</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>intermediate key</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getCipher-javax.crypto.SecretKey-org.apache.poi.poifs.crypt.CipherAlgorithm-org.apache.poi.poifs.crypt.ChainingMode-byte:A-int-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getCipher</h4>
                                <pre>public static&nbsp;javax.crypto.Cipher&nbsp;getCipher(javax.crypto.SecretKey&nbsp;key,
                                            <a href="../../../../../org/apache/poi/poifs/crypt/CipherAlgorithm.html"
                                               title="enum in org.apache.poi.poifs.crypt">CipherAlgorithm</a>&nbsp;cipherAlgorithm,
                                            <a href="../../../../../org/apache/poi/poifs/crypt/ChainingMode.html"
                                               title="enum in org.apache.poi.poifs.crypt">ChainingMode</a>&nbsp;chain,
                                            byte[]&nbsp;vec,
                                            int&nbsp;cipherMode)</pre>
                                <div class="block">Initialize a new cipher object with the given cipher properties and
                                    no padding
                                    If the given algorithm is not implemented in the JCE, it will try to load it from
                                    the bouncy castle
                                    provider.
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>key</code> - the secret key</dd>
                                    <dd><code>cipherAlgorithm</code> - the cipher algorithm</dd>
                                    <dd><code>chain</code> - the chaining mode</dd>
                                    <dd><code>vec</code> - the initialization vector (IV), can be null</dd>
                                    <dd><code>cipherMode</code> - Cipher.DECRYPT_MODE or Cipher.ENCRYPT_MODE</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>the requested cipher</dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.security.GeneralSecurityException</code></dd>
                                    <dd><code><a href="../../../../../org/apache/poi/EncryptedDocumentException.html"
                                                 title="class in org.apache.poi">EncryptedDocumentException</a></code> -
                                        if the initialization failed or if an algorithm was specified,
                                        which depends on a missing bouncy castle provider
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getCipher-java.security.Key-org.apache.poi.poifs.crypt.CipherAlgorithm-org.apache.poi.poifs.crypt.ChainingMode-byte:A-int-java.lang.String-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getCipher</h4>
                                <pre>public static&nbsp;javax.crypto.Cipher&nbsp;getCipher(java.security.Key&nbsp;key,
                                            <a href="../../../../../org/apache/poi/poifs/crypt/CipherAlgorithm.html"
                                               title="enum in org.apache.poi.poifs.crypt">CipherAlgorithm</a>&nbsp;cipherAlgorithm,
                                            <a href="../../../../../org/apache/poi/poifs/crypt/ChainingMode.html"
                                               title="enum in org.apache.poi.poifs.crypt">ChainingMode</a>&nbsp;chain,
                                            byte[]&nbsp;vec,
                                            int&nbsp;cipherMode,
                                            java.lang.String&nbsp;padding)</pre>
                                <div class="block">Initialize a new cipher object with the given cipher properties
                                    If the given algorithm is not implemented in the JCE, it will try to load it from
                                    the bouncy castle
                                    provider.
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>key</code> - the secret key</dd>
                                    <dd><code>cipherAlgorithm</code> - the cipher algorithm</dd>
                                    <dd><code>chain</code> - the chaining mode</dd>
                                    <dd><code>vec</code> - the initialization vector (IV), can be null</dd>
                                    <dd><code>cipherMode</code> - Cipher.DECRYPT_MODE or Cipher.ENCRYPT_MODE</dd>
                                    <dd><code>padding</code> - the padding (null = NOPADDING, ANSIX923Padding,
                                        PKCS5Padding, PKCS7Padding, ISO10126Padding, ...)
                                    </dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>the requested cipher</dd>
                                    <dt><span class="throwsLabel">Throws:</span></dt>
                                    <dd><code>java.security.GeneralSecurityException</code></dd>
                                    <dd><code><a href="../../../../../org/apache/poi/EncryptedDocumentException.html"
                                                 title="class in org.apache.poi">EncryptedDocumentException</a></code> -
                                        if the initialization failed or if an algorithm was specified,
                                        which depends on a missing bouncy castle provider
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getBlock0-byte:A-int-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getBlock0</h4>
                                <pre>public static&nbsp;byte[]&nbsp;getBlock0(byte[]&nbsp;hash,
                               int&nbsp;size)</pre>
                                <div class="block">Returns a new byte array with a truncated to the given size.
                                    If the hash has less then size bytes, it will be filled with 0-bytes
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>hash</code> - the to be truncated/filled hash byte array</dd>
                                    <dd><code>size</code> - the size of the returned byte array</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>the padded hash</dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="getMessageDigest-org.apache.poi.poifs.crypt.HashAlgorithm-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getMessageDigest</h4>
                                <pre>public static&nbsp;java.security.MessageDigest&nbsp;getMessageDigest(<a
                                        href="../../../../../org/apache/poi/poifs/crypt/HashAlgorithm.html"
                                        title="enum in org.apache.poi.poifs.crypt">HashAlgorithm</a>&nbsp;hashAlgorithm)</pre>
                            </li>
                        </ul>
                        <a name="getMac-org.apache.poi.poifs.crypt.HashAlgorithm-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>getMac</h4>
                                <pre>public static&nbsp;javax.crypto.Mac&nbsp;getMac(<a
                                        href="../../../../../org/apache/poi/poifs/crypt/HashAlgorithm.html"
                                        title="enum in org.apache.poi.poifs.crypt">HashAlgorithm</a>&nbsp;hashAlgorithm)</pre>
                            </li>
                        </ul>
                        <a name="registerBouncyCastle--">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>registerBouncyCastle</h4>
                                <pre>public static&nbsp;void&nbsp;registerBouncyCastle()</pre>
                            </li>
                        </ul>
                        <a name="createXorVerifier1-java.lang.String-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>createXorVerifier1</h4>
                                <pre>public static&nbsp;int&nbsp;createXorVerifier1(java.lang.String&nbsp;password)</pre>
                                <div class="block">Create the verifier for xor obfuscation (method 1)</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>password</code> - the password</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>the verifier (actually a short value)</dd>
                                    <dt><span class="seeLabel">See Also:</span></dt>
                                    <dd><a href="http://msdn.microsoft.com/en-us/library/dd926947.aspx">2.3.7.1 Binary
                                        Document Password Verifier Derivation Method 1</a>,
                                        <a href="http://msdn.microsoft.com/en-us/library/dd905229.aspx">2.3.7.4 Binary
                                            Document Password Verifier Derivation Method 2</a>,
                                        <a href="http://www.ecma-international.org/news/TC45_current_work/Office Open XML Part 4 - Markup Language Reference.pdf">Part
                                            4 - Markup Language Reference - Ecma International - 3.2.12 fileSharing</a>
                                    </dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="createXorVerifier2-java.lang.String-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>createXorVerifier2</h4>
                                <pre>public static&nbsp;int&nbsp;createXorVerifier2(java.lang.String&nbsp;password)</pre>
                                <div class="block">This method generates the xor verifier for word documents &lt; 2007
                                    (method 2).
                                    Its output will be used as password input for the newer word generations which
                                    utilize a real hashing algorithm like sha1.
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>password</code> - the password</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>the hashed password</dd>
                                    <dt><span class="seeLabel">See Also:</span></dt>
                                    <dd><a href="http://msdn.microsoft.com/en-us/library/dd905229.aspx">2.3.7.4 Binary
                                        Document Password Verifier Derivation Method 2</a>,
                                        <a href="http://blogs.msdn.com/b/vsod/archive/2010/04/05/how-to-set-the-editing-restrictions-in-word-using-open-xml-sdk-2-0.aspx">How
                                            to set the editing restrictions in Word using Open XML SDK 2.0</a>,
                                        <a href="http://www.aspose.com/blogs/aspose-blogs/vladimir-averkin/archive/2007/08/20/funny-how-the-new-powerful-cryptography-implemented-in-word-2007-turns-it-into-a-perfect-tool-for-document-password-removal.html">Funny:
                                            How the new powerful cryptography implemented in Word 2007 turns it into a
                                            perfect tool for document password removal.</a></dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="xorHashPassword-java.lang.String-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>xorHashPassword</h4>
                                <pre>public static&nbsp;java.lang.String&nbsp;xorHashPassword(java.lang.String&nbsp;password)</pre>
                                <div class="block">This method generates the xored-hashed password for word documents
                                    &lt; 2007.
                                </div>
                            </li>
                        </ul>
                        <a name="xorHashPasswordReversed-java.lang.String-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>xorHashPasswordReversed</h4>
                                <pre>public static&nbsp;java.lang.String&nbsp;xorHashPasswordReversed(java.lang.String&nbsp;password)</pre>
                                <div class="block">Convenience function which returns the reversed xored-hashed password
                                    for further
                                    processing in word documents 2007 and newer, which utilize a real hashing algorithm
                                    like sha1.
                                </div>
                            </li>
                        </ul>
                        <a name="createXorKey1-java.lang.String-">
                            <!--   -->
                        </a>
                        <ul class="blockList">
                            <li class="blockList">
                                <h4>createXorKey1</h4>
                                <pre>public static&nbsp;int&nbsp;createXorKey1(java.lang.String&nbsp;password)</pre>
                                <div class="block">Create the xor key for xor obfuscation, which is used to create the
                                    xor array (method 1)
                                </div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>password</code> - the password</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>the xor key</dd>
                                    <dt><span class="seeLabel">See Also:</span></dt>
                                    <dd><a href="http://msdn.microsoft.com/en-us/library/dd924704.aspx">2.3.7.2 Binary
                                        Document XOR Array Initialization Method 1</a>,
                                        <a href="http://msdn.microsoft.com/en-us/library/dd905229.aspx">2.3.7.4 Binary
                                            Document Password Verifier Derivation Method 2</a></dd>
                                </dl>
                            </li>
                        </ul>
                        <a name="createXorArray1-java.lang.String-">
                            <!--   -->
                        </a>
                        <ul class="blockListLast">
                            <li class="blockList">
                                <h4>createXorArray1</h4>
                                <pre>public static&nbsp;byte[]&nbsp;createXorArray1(java.lang.String&nbsp;password)</pre>
                                <div class="block">Creates an byte array for xor obfuscation (method 1)</div>
                                <dl>
                                    <dt><span class="paramLabel">Parameters:</span></dt>
                                    <dd><code>password</code> - the password</dd>
                                    <dt><span class="returnLabel">Returns:</span></dt>
                                    <dd>the byte array for xor obfuscation</dd>
                                    <dt><span class="seeLabel">See Also:</span></dt>
                                    <dd><a href="http://msdn.microsoft.com/en-us/library/dd924704.aspx">2.3.7.2 Binary
                                        Document XOR Array Initialization Method 1</a>,
                                        <a href="http://docs.libreoffice.org/oox/html/binarycodec_8cxx_source.html">Libre
                                            Office implementation</a></dd>
                                </dl>
                            </li>
                        </ul>
                    </li>
                </ul>
            </li>
        </ul>
    </div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
    <!--   -->
</a>
    <div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
    <a name="navbar.bottom.firstrow">
        <!--   -->
    </a>
    <ul class="navList" title="Navigation">
        <li><a href="../../../../../overview-summary.html">Overview</a></li>
        <li><a href="package-summary.html">Package</a></li>
        <li class="navBarCell1Rev">Class</li>
        <li><a href="class-use/CryptoFunctions.html">Use</a></li>
        <li><a href="package-tree.html">Tree</a></li>
        <li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
        <li><a href="../../../../../index-all.html">Index</a></li>
        <li><a href="../../../../../help-doc.html">Help</a></li>
    </ul>
</div>
<div class="subNav">
    <ul class="navList">
        <li><a href="../../../../../org/apache/poi/poifs/crypt/CipherProvider.html"
               title="enum in org.apache.poi.poifs.crypt"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
        <li><a href="../../../../../org/apache/poi/poifs/crypt/DataSpaceMapUtils.html"
               title="class in org.apache.poi.poifs.crypt"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
    </ul>
    <ul class="navList">
        <li><a href="../../../../../index.html?org/apache/poi/poifs/crypt/CryptoFunctions.html" target="_top">Frames</a>
        </li>
        <li><a href="CryptoFunctions.html" target="_top">No&nbsp;Frames</a></li>
    </ul>
    <ul class="navList" id="allclasses_navbar_bottom">
        <li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
    </ul>
    <div>
        <script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->

        </script>
    </div>
    <div>
        <ul class="subNavList">
            <li>Summary:&nbsp;</li>
            <li>Nested&nbsp;|&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.summary">Method</a></li>
        </ul>
        <ul class="subNavList">
            <li>Detail:&nbsp;</li>
            <li>Field&nbsp;|&nbsp;</li>
            <li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
            <li><a href="#method.detail">Method</a></li>
        </ul>
    </div>
    <a name="skip.navbar.bottom">
        <!--   -->
    </a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy">
    <small>
        <i>Copyright 2018 The Apache Software Foundation or
            its licensors, as applicable.</i>
    </small>
</p>
</body>
</html>
